#include <sourcemod>
#include <sdktools>
#include <sdkhooks>

#define PLUGIN_VERSION "1.1"

public Plugin:myinfo = 
{
	name = "DoD Realistic Reload",
	author = "FeuerSturm",
	description = "Reload your weapon based on magazine count!",
	version = PLUGIN_VERSION,
	url = "http://www.dodsourceplugins.net"
}

#define MAXWEAPONS 13

new g_iAmmo, g_iClip1, g_Deployed

new String:g_Weapon[MAXWEAPONS][] =
{
	"weapon_colt", "weapon_p38", "weapon_m1carbine", "weapon_c96",
	"weapon_k98", "weapon_thompson", "weapon_mp40", "weapon_bar", "weapon_mp44",
	"weapon_spring", "weapon_k98_scoped", "weapon_30cal", "weapon_mg42"
}

new g_ClipSize[MAXWEAPONS] =
{
	7, 8, 15, 20, 5, 30, 30, 20, 30, 5, 5, 150, 250
}

new g_AmmoOffs[MAXWEAPONS] =
{
	4, 8, 24, 12, 20, 32, 32, 36, 32, 28, 20, 40, 44
}

new Handle:RealisticReload = INVALID_HANDLE

public OnPluginStart()
{
	RealisticReload = CreateConVar("dod_realisticreload", "0", "<1/0> = enable/disable DoD Realistic Reload", FCVAR_PLUGIN, true, 0.0, true, 1.0)
}

public OnMapStart()
{
	g_iAmmo = FindSendPropOffs("CDODPlayer", "m_iAmmo")
	g_iClip1 = FindSendPropInfo("CBaseCombatWeapon", "m_iClip1")
	g_Deployed = FindSendPropInfo("CDODBipodWeapon", "m_bDeployed")
}

public OnClientPutInServer(client)
{
	SDKHook(client, SDKHook_PreThink, OnPreThink)
	HookEventEx("dod_stats_weapon_attack", OnWeaponAttack, EventHookMode_Post)
}

public Action:OnWeaponAttack(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(GetConVarInt(RealisticReload) == 0)
	{
		return Plugin_Continue
	}
	new client = GetClientOfUserId(GetEventInt(event, "attacker"))
	if(client < 1 || client > MaxClients || !IsClientInGame(client))
	{
		return Plugin_Continue
	}
	new weaponid = GetEventInt(event, "weapon")
	if(weaponid == 25 || weaponid == 26)
	{
		new wpn = GetPlayerWeaponSlot(client, 0)
		new CurClip = GetEntData(wpn, g_iClip1)
		SetEntData(wpn, g_iClip1, CurClip-1, 4, true)
	}
	return Plugin_Continue
}

public OnPreThink(client)
{
	if(GetConVarInt(RealisticReload) == 1)
	{
		if(IsClientInGame(client) && IsPlayerAlive(client) && GetClientTeam(client) > 1)
		{
			decl String:Weapon[32]
			GetClientWeapon(client, Weapon, sizeof(Weapon))
			new buttons = GetClientButtons(client)
			if(buttons & IN_RELOAD)
			{
				new WeaponID = -1
				for(new i = 0; i < MAXWEAPONS; i++)
				{
					if(strcmp(Weapon,g_Weapon[i]) == 0)
					{
						WeaponID = i
					}
				}
				if(WeaponID != -1)
				{
					new wpn
					if(WeaponID > 3)
					{
						wpn = GetPlayerWeaponSlot(client, 0)
						if((WeaponID == 11 || WeaponID == 12) && GetEntData(wpn, g_Deployed) == 0)
						{
							return
						}
					}
					else
					{
						wpn = GetPlayerWeaponSlot(client, 1)
					}
					new CurClip = GetEntData(wpn, g_iClip1)
					new AmmoOffs = g_iAmmo + g_AmmoOffs[WeaponID]
					new BackPack = GetEntData(client, AmmoOffs)
					if(CurClip < g_ClipSize[WeaponID] && CurClip > 0 && BackPack + CurClip >= g_ClipSize[WeaponID])
					{
						if(GetEntData(wpn, g_iClip1) > 0)
						{
							SetEntData(wpn, g_iClip1, 0, 4, true)
						}
					}
				}
			}
			if(StrEqual(Weapon, "weapon_riflegren_us") || StrEqual(Weapon, "weapon_riflegren_ger"))
			{
				new Rifle = GetPlayerWeaponSlot(client, 0)
				new RifleClip = GetEntData(Rifle, g_iClip1)
				if(RifleClip == 0)
				{
					new Nade = GetPlayerWeaponSlot(client, 3)
					new NadeClip = GetEntData(Nade, g_iClip1)
					if(NadeClip != 0)
					{
						if(buttons & IN_ATTACK)
						{
							PrintCenterText(client, "You CANNOT fire a grenade, reload your rifle first!")
						}
						SetEntPropFloat(client, Prop_Send, "m_flNextAttack", GetGameTime()+0.5)
					}
					return
				}
			}
		}
	}
}